doc(bklog-plan): Add TODO feature: config file parsing
[EVA-2020-02.git] / exec / bkgpslog
index d44788661b4f9d6ece2089e39cde3e7df8fe2b3d..d8eeff71d338c83b86ace5c22adfcd4808fb5e20 100755 (executable)
@@ -1,31 +1,36 @@
 #!/bin/bash
 #!/bin/bash
-
-# Desc: Records gps data until midnight
-# Author: Steven Baltakatei Sandoval; License: GPLv3+
-# Usage: bkgpslog -o [output dir]
+# Desc: Records gps data
 
 #==BEGIN Define script parameters==
 ## Logging Behavior parameters
 
 #==BEGIN Define script parameters==
 ## Logging Behavior parameters
-BUFFER_TTL="60"; # time between file writes
-SCRIPT_TTL="day"; # (day|hour)
+bufferTTL="300"; # time between file writes
+scriptTTL_TE="day"; # (day|hour)
 #### TZ="UTC"; export TZ; # Default time zone; overridden by '--time-zone=[str]' option
 #### TZ="UTC"; export TZ; # Default time zone; overridden by '--time-zone=[str]' option
-DIR_TMP_DEFAULT="/dev/shm"; # Default parent of working directory
+dirTmpDefault="/dev/shm"; # Default parent of working directory
 
 
-SCRIPT_TIME_START=$(date +%Y%m%dT%H%M%S.%N);
+scriptTimeStart=$(date +%Y%m%dT%H%M%S.%N);
 PATH="$HOME/.local/bin:$PATH";   # Add "$(systemd-path user-binaries)" path in case apps saved there
 PATH="$HOME/.local/bin:$PATH";   # Add "$(systemd-path user-binaries)" path in case apps saved there
-SCRIPT_HOSTNAME=$(hostname);     # Save hostname of system running this script.
-SCRIPT_VERSION="bkgpslog 0.1.0"; # Define version of script.
+scriptHostname=$(hostname);     # Save hostname of system running this script.
+scriptVersion="0.5.8";          # Define version of script.
+scriptName="bkgpslog";          # Define basename of script file.
+scriptURL="https://gitlab.com/baltakatei/ninfacyzga-01"; # Define wesite hosting this script.
+ageVersion="1.0.0-beta2";       # Define version of age (encryption program)
+ageURL="https://github.com/FiloSottile/age/releases/tag/v1.0.0-beta2"; # Define website hosting age.
 
 declare -Ag appRollCall # Associative array for storing app status
 declare -Ag fileRollCall # Associative array for storing file status
 declare -Ag dirRollCall # Associative array for storing dir status
 
 declare -Ag appRollCall # Associative array for storing app status
 declare -Ag fileRollCall # Associative array for storing file status
 declare -Ag dirRollCall # Associative array for storing dir status
-declare -a recPubKeys # for processArguments function
-declare recipients # for main function
+declare -a argRecPubKeys # for processArguments function
+# declare -a errorHistory # for correcting buffer lag
 
 ## Initialize variables
 
 ## Initialize variables
-OPTION_VERBOSE=""; OPTION_ENCRYPT=""; OPTION_COMPRESS=""; OPTION_TMPDIR="";
+optionVerbose=""; optionEncrypt=""; optionCompress=""; optionTmpDir="";
+errReset=0; bufferTTL_AdjFloat=""; scriptTTL="";
 
 #===BEGIN Declare local script functions===
 
 #===BEGIN Declare local script functions===
+yell() { echo "$0: $*" >&2; }      #o Yell, Die, Try Three-Fingered Claw technique
+die() { yell "$*"; exit 111; }     #o Ref/Attrib: https://stackoverflow.com/a/25515370
+try() { "$@" || die "cannot $*"; } #o 
 checkapp() {
     # Desc: If arg is a command, save result in assoc array 'appRollCall'
     # Usage: checkapp arg1 arg2 arg3 ...
 checkapp() {
     # Desc: If arg is a command, save result in assoc array 'appRollCall'
     # Usage: checkapp arg1 arg2 arg3 ...
@@ -126,13 +131,6 @@ checkdir() {
        return 1;
     fi
 } # Check that dir exists
        return 1;
     fi
 } # Check that dir exists
-
-# Yell, Die, Try Three-Fingered Claw technique
-# Ref/Attrib: https://stackoverflow.com/a/25515370
-yell() { echo "$0: $*" >&2; }
-die() { yell "$*"; exit 111; }
-try() { "$@" || die "cannot $*"; }
-
 echoerr() {
     echo "$@" 1>&2; # Define stderr echo function.
 } # Define stderr message function.
 echoerr() {
     echo "$@" 1>&2; # Define stderr echo function.
 } # Define stderr message function.
@@ -143,64 +141,60 @@ showUsage() {
     echoerr "OPTIONS:"
     echoerr "    -h, --help"
     echoerr "            Display help information."
     echoerr "OPTIONS:"
     echoerr "    -h, --help"
     echoerr "            Display help information."
-    echoerr
     echoerr "    --version"
     echoerr "            Display script version."
     echoerr "    --version"
     echoerr "            Display script version."
-    echoerr
     echoerr "    -v, --verbose"
     echoerr "            Display debugging info."
     echoerr "    -v, --verbose"
     echoerr "            Display debugging info."
-    echoerr
     echoerr "    -e, --encrypt"
     echoerr "            Encrypt output."
     echoerr "    -e, --encrypt"
     echoerr "            Encrypt output."
-    echoerr
-    echoerr "    -r, --recipient [ pubkey string ]"
+    echoerr "    -r, --recipient [ string pubkey ]"
     echoerr "            Specify recipient. May be age or ssh pubkey."
     echoerr "            Specify recipient. May be age or ssh pubkey."
+    echoerr "            May be specified multiple times for multiple pubkeys."
     echoerr "            See https://github.com/FiloSottile/age"
     echoerr "            See https://github.com/FiloSottile/age"
-    echoerr
-    echoerr "    -o, --output [ directory ]"
+    echoerr "    -o, --output [ path dir ]"
     echoerr "            Specify output directory to save logs."
     echoerr "            Specify output directory to save logs."
-    echoerr
     echoerr "    -c, --compress"
     echoerr "            Compress output with gzip (before encryption if enabled)."
     echoerr "    -c, --compress"
     echoerr "            Compress output with gzip (before encryption if enabled)."
-    echoerr
     echoerr "    -z, --time-zone"
     echoerr "            Specify time zone. (ex: \"America/New_York\")"
     echoerr "    -z, --time-zone"
     echoerr "            Specify time zone. (ex: \"America/New_York\")"
-    echoerr
-    echoerr "    -t, --temp-dir"
+    echoerr "    -t, --temp-dir [path dir]"
     echoerr "            Specify parent directory for temporary working directory."
     echoerr "            Default: \"/dev/shm\""
     echoerr "            Specify parent directory for temporary working directory."
     echoerr "            Default: \"/dev/shm\""
+    echoerr "    -R, --recipient-dir [path dir]"
+    echoerr "            Specify directory containing files whose first lines are"
+    echoerr "            to be interpreted as pubkey strings (see \\'-r\\' option)."
+    echoerr "    -b, --buffer-ttl [integer]"
+    echoerr "            Specify custom buffer period in seconds (default: 300 seconds)"
+    echoerr "    -B, --script-ttl [integer]"
+    echoerr "            Specify custom script time-to-live in seconds (default: \"day\")"
     echoerr
     echoerr "EXAMPLE: (bash script lines)"
     echoerr
     echoerr "EXAMPLE: (bash script lines)"
-    echoerr "/bin/bash bkgpslog -e -c \\"
+    echoerr "/bin/bash bkgpslog -v -e -c \\"
+    echoerr "-z \"UTC\" -t \"/dev/shm\" \\"
     echoerr "-r age1mrmfnwhtlprn4jquex0ukmwcm7y2nxlphuzgsgv8ew2k9mewy3rs8u7su5 \\"
     echoerr "-r age1ala848kqrvxc88rzaauc6vc5v0fqrvef9dxyk79m0vjea3hagclswu0lgq \\"
     echoerr "-o ~/Sync/Location"
 } # Display information on how to use this script.
 showVersion() {
     echoerr "-r age1mrmfnwhtlprn4jquex0ukmwcm7y2nxlphuzgsgv8ew2k9mewy3rs8u7su5 \\"
     echoerr "-r age1ala848kqrvxc88rzaauc6vc5v0fqrvef9dxyk79m0vjea3hagclswu0lgq \\"
     echoerr "-o ~/Sync/Location"
 } # Display information on how to use this script.
 showVersion() {
-    echoerr "$SCRIPT_VERSION"
+    echoerr "$scriptVersion"
 } # Display script version.
 vbm() {
 } # Display script version.
 vbm() {
+    # Description: Prints verbose message ("vbm") to stderr if optionVerbose is set to "true".
     # Usage: vbm "DEBUG:verbose message here"
     # Usage: vbm "DEBUG:verbose message here"
-    # Description: Prints verbose message ("vbm") to stderr if OPTION_VERBOSE is set to "true".
-    # Input:
-    #   - OPTION_VERBOSE  variable set by processArguments function. (ex: "true", "false")
-    #   - "$@"            positional arguments fed to this function.
+    # Version 0.1.1
+    # Input: arg1: string
+    #        vars: optionVerbose
     # Output: stderr
     # Output: stderr
-    # Script function dependencies: echoerr
-    # External function dependencies: echo
-    # Last modified: 2020-04-11T23:57Z
-    # Last modified by: Steven Baltakatei Sandoval
-    # License: GPLv3+
-    # Ref./Attrib:
-
-    if [ "$OPTION_VERBOSE" = "true" ]; then
-       FUNCTION_TIME=$(date --iso-8601=ns); # Save current time in nano seconds.
-       echoerr "[$FUNCTION_TIME] ""$*"; # Display argument text.
+    # Depends: echo 8, date 8
+
+    if [ "$optionVerbose" = "true" ]; then
+       functionTime=$(date --iso-8601=ns); # Save current time in nano seconds.
+       echo "[$functionTime] ""$*" 1>&2; # Display argument text.
     fi
 
     # End function
     return 0; # Function finished.
     fi
 
     # End function
     return 0; # Function finished.
-} # Verbose message display function.
+} # Displays message if optionVerbose true
 processArguments() {
     while [ ! $# -eq 0 ]; do   # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
        #echoerr "DEBUG:Starting processArguments while loop."
 processArguments() {
     while [ ! $# -eq 0 ]; do   # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
        #echoerr "DEBUG:Starting processArguments while loop."
@@ -208,14 +202,16 @@ processArguments() {
        case "$1" in
            -h | --help) showUsage; exit 1;; # Display usage.
            --version) showVersion; exit 1;; # Show version
        case "$1" in
            -h | --help) showUsage; exit 1;; # Display usage.
            --version) showVersion; exit 1;; # Show version
-           -v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
-           -o | --output) if [ -d "$2" ]; then DIR_OUT="$2"; vbm "DEBUG:DIR_OUT:$DIR_OUT"; shift; fi ;; # Define output directory.
-           -e | --encrypt) OPTION_ENCRYPT="true"; vbm "DEBUG:Encrypted output mode enabled.";;
-           -r | --recipient) # Add 'age' recipient via public key string
-               recPubKeys+=("$2"); vbm "STATUS:pubkey added:""$2"; shift;;
-           -c | --compress) OPTION_COMPRESS="true"; vbm "DEBUG:Compressed output mode enabled.";;
-           -z | --time-zone) try setTimeZoneEV "$2"; shift;;
-           -t | --temp-dir) OPTION_TMPDIR="true" && TMP_DIR_PRIORITY="$2"; shift;;
+           -v | --verbose) optionVerbose="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
+           -o | --output) if [ -d "$2" ]; then dirOut="$2"; vbm "DEBUG:dirOut:$dirOut"; shift; fi ;; # Define output directory.
+           -e | --encrypt) optionEncrypt="true"; vbm "DEBUG:Encrypted output mode enabled.";; # Enable encryption
+           -r | --recipient) optionRecipients="true"; argRecPubKeys+=("$2"); vbm "STATUS:pubkey added:""$2"; shift;; # Add recipients
+           -c | --compress) optionCompress="true"; vbm "DEBUG:Compressed output mode enabled.";; # Enable compression
+           -z | --time-zone) try setTimeZoneEV "$2"; shift;; # Set timestamp timezone
+           -t | --temp-dir) optionTmpDir="true" && argTempDirPriority="$2"; shift;; # Set time zone
+           -R | --recipient-dir) optionRecipients="true"; optionRecDir="true" && argRecDir="$2"; shift;; # Add recipient watch dir
+           -b | --buffer-ttl) optionCustomBufferTTL="true" && argCustomBufferTTL="$2"; shift;; # Set custom buffer period (default: 300 seconds)
+           -B | --script-ttl) optionCustomScriptTTL_TE="true" && argCustomScriptTTL="$2"; shift;; # Set custom script TTL (default: "day")
            *) echoerr "ERROR: Unrecognized argument: $1"; echoerr "STATUS:All arguments:$*"; exit 1;; # Handle unrecognized options.
        esac
        shift
            *) echoerr "ERROR: Unrecognized argument: $1"; echoerr "STATUS:All arguments:$*"; exit 1;; # Handle unrecognized options.
        esac
        shift
@@ -224,6 +220,7 @@ processArguments() {
 setTimeZoneEV(){
     # Desc: Set time zone environment variable TZ
     # Usage: setTimeZoneEV arg1
 setTimeZoneEV(){
     # Desc: Set time zone environment variable TZ
     # Usage: setTimeZoneEV arg1
+    # Version 0.1.1
     # Input: arg1: 'date'-compatible timezone string (ex: "America/New_York")
     #        TZDIR env var (optional; default: "/usr/share/zoneinfo")
     # Output: exports TZ
     # Input: arg1: 'date'-compatible timezone string (ex: "America/New_York")
     #        TZDIR env var (optional; default: "/usr/share/zoneinfo")
     # Output: exports TZ
@@ -232,8 +229,9 @@ setTimeZoneEV(){
     #         exit code 2 if unable to validate arg1
     # Depends: yell, printenv, bash 5
     # Tested on: Debian 10
     #         exit code 2 if unable to validate arg1
     # Depends: yell, printenv, bash 5
     # Tested on: Debian 10
-    ARG1="$1"
-    local tzDir returnState
+    local tzDir returnState argTimeZone
+
+    argTimeZone="$1"
     if ! [[ $# -eq 1 ]]; then
        yell "ERROR:Invalid argument count.";
        return 1;
     if ! [[ $# -eq 1 ]]; then
        yell "ERROR:Invalid argument count.";
        return 1;
@@ -247,12 +245,12 @@ setTimeZoneEV(){
     fi
     
     # Validate TZ string
     fi
     
     # Validate TZ string
-    if ! [[ -f "$tzDir"/"$ARG1" ]]; then
+    if ! [[ -f "$tzDir"/"$argTimeZone" ]]; then
        yell "ERROR:Invalid time zone argument.";
        return 2;
     else
     # Export ARG1 as TZ environment variable
        yell "ERROR:Invalid time zone argument.";
        return 2;
     else
     # Export ARG1 as TZ environment variable
-       TZ="$ARG1" && export TZ && returnState="true";
+       TZ="$argTimeZone" && export TZ && returnState="true";
     fi
 
     # Determine function return code
     fi
 
     # Determine function return code
@@ -262,136 +260,190 @@ setTimeZoneEV(){
 } # Exports TZ environment variable
 timeUntilNextDay(){
     # Desc: Report seconds until next day.
 } # Exports TZ environment variable
 timeUntilNextDay(){
     # Desc: Report seconds until next day.
+    # Version: 1.0.2
     # Output: stdout: integer seconds until next day
     # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
     # Usage: timeUntilNextDay
     # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
     # Output: stdout: integer seconds until next day
     # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
     # Usage: timeUntilNextDay
     # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
-    local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
-    TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
-    TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
-    SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
-    if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
+    # Depends: date 8, echo 8, yell, try
+    
+    local returnState timeCurrent timeNextDay secondsUntilNextDay returnState
+    timeCurrent="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
+    timeNextDay="$(date -d "$timeCurrent next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
+    secondsUntilNextDay="$(( $(date +%s -d "$timeNextDay") - $(date +%s -d "$timeCurrent") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
+    if [[ "$secondsUntilNextDay" -gt 0 ]]; then
        returnState="true";
        returnState="true";
-    elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
-       returnState="WARNING_ZERO";
+    elif [[ "$secondsUntilNextDay" -eq 0 ]]; then
+       returnState="warning_zero";
        yell "WARNING:Reported time until next day exactly zero.";
        yell "WARNING:Reported time until next day exactly zero.";
-    elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
-       returnState="WARNING_NEGATIVE";
+    elif [[ "$secondsUntilNextDay" -lt 0 ]]; then
+       returnState="warning_negative";
        yell "WARNING:Reported time until next day is negative.";
     fi
 
        yell "WARNING:Reported time until next day is negative.";
     fi
 
-    try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
+    try echo "$secondsUntilNextDay"; # Report
     
     
-    #===Determine function return code===
+    # Determine function return code
     if [[ "$returnState" = "true" ]]; then
        return 0;
     if [[ "$returnState" = "true" ]]; then
        return 0;
-    elif [[ "$returnState" = "WARNING_ZERO" ]]; then
+    elif [[ "$returnState" = "warning_zero" ]]; then
        return 1;
        return 1;
-    elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
+    elif [[ "$returnState" = "warning_negative" ]]; then
        return 2;
     fi
 } # Report seconds until next day
 timeUntilNextHour(){
     # Desc: Report seconds until next hour
        return 2;
     fi
 } # Report seconds until next day
 timeUntilNextHour(){
     # Desc: Report seconds until next hour
+    # Version 1.0.1
     # Output: stdout: integer seconds until next hour
     # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
     # Usage: timeUntilNextHour
     # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
     # Output: stdout: integer seconds until next hour
     # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
     # Usage: timeUntilNextHour
     # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
-    local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
-    TIME_CURRENT="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
-    TIME_NEXT_HOUR="$(date -d "$TIME_CURRENT next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
-    SECONDS_UNTIL_NEXT_HOUR="$(( $(date +%s -d "$TIME_NEXT_HOUR") - $(date +%s -d "$TIME_CURRENT") ))"; # Calculate seconds until next hour (res. 1 second).
-    if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
+    
+    local returnState timeCurrent timeNextHour secondsUntilNextHour
+    timeCurrent="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
+    timeNextHour="$(date -d "$timeCurrent next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
+    secondsUntilNextHour="$(( $(date +%s -d "$timeNextHour") - $(date +%s -d "$timeCurrent") ))"; # Calculate seconds until next hour (res. 1 second).
+    if [[ "$secondsUntilNextHour" -gt 0 ]]; then
        returnState="true";
        returnState="true";
-    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
-       returnState="WARNING_ZERO";
+    elif [[ "$secondsUntilNextHour" -eq 0 ]]; then
+       returnState="warning_zero";
        yell "WARNING:Reported time until next hour exactly zero.";
        yell "WARNING:Reported time until next hour exactly zero.";
-    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
-       returnState="WARNING_NEGATIVE";
+    elif [[ "$secondsUntilNextHour" -lt 0 ]]; then
+       returnState="warning_negative";
        yell "WARNING:Reported time until next hour is negative.";
        yell "WARNING:Reported time until next hour is negative.";
-    fi
+    fi;
 
 
-    try echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
+    try echo "$secondsUntilNextHour"; # Report
     
     
-    #===Determine function return code===
+    # Determine function return code
     if [[ "$returnState" = "true" ]]; then
        return 0;
     if [[ "$returnState" = "true" ]]; then
        return 0;
-    elif [[ "$returnState" = "WARNING_ZERO" ]]; then
+    elif [[ "$returnState" = "warning_zero" ]]; then
        return 1;
        return 1;
-    elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
+    elif [[ "$returnState" = "warning_negative" ]]; then
        return 2;
        return 2;
-    fi
+    fi;
 } # Report seconds until next hour
 dateTimeShort(){
     # Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
 } # Report seconds until next hour
 dateTimeShort(){
     # Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
-    # Usage: dateTimeShort
+    # Usage: dateTimeShort ([str date])
+    # Version 1.1.1
+    # Input: arg1: 'date'-parsable timestamp string (optional)
     # Output: stdout: timestamp (ISO-8601, no separators)
     # Output: stdout: timestamp (ISO-8601, no separators)
-    local TIME_CURRENT TIME_CURRENT_SHORT
-    TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
-    TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)"; # Produce separator-less current timestamp with resolution 1 second.
-    echo "$TIME_CURRENT_SHORT";
+    # Depends: yell
+    local argTime timeCurrent timeInput timeCurrentShort
+
+    argTime="$1";
+    # Get Current Time
+    timeCurrent="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
+    # Decide to parse current or supplied date
+    ## Check if time argument empty
+    if [[ -z "$argTime" ]]; then
+       ## T: Time argument empty, use current time
+       timeInput="$timeCurrent";
+    else
+       ## F: Time argument exists, validate time
+       if date --date="$argTime" 1>/dev/null 2>&1; then
+           ### T: Time argument is valid; use it
+           timeInput="$argTime";
+       else
+           ### F: Time argument not valid; exit
+           yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+       fi
+    fi
+    # Construct and deliver separator-les date string
+    timeCurrentShort="$(date -d "$timeInput" +%Y%m%dT%H%M%S%z)";
+    echo "$timeCurrentShort";
 } # Get YYYYmmddTHHMMSS±zzzz
 dateShort(){
     # Desc: Date without separators (YYYYmmdd)
 } # Get YYYYmmddTHHMMSS±zzzz
 dateShort(){
     # Desc: Date without separators (YYYYmmdd)
-    # Usage: dateShort
+    # Usage: dateShort ([str date])
+    # Version: 1.1.1
+    # Input: arg1: 'date'-parsable timestamp string (optional)
     # Output: stdout: date (ISO-8601, no separators)
     # Output: stdout: date (ISO-8601, no separators)
-    local TIME_CURRENT DATE_CURRENT_SHORT
-    TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
-    DATE_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%d)"; # Produce separator-less current date with resolution 1 day.
-    echo "$DATE_CURRENT_SHORT";
+    # Depends: yell
+    local argTime timeCurrent timeInput dateCurrentShort
+
+    argTime="$1";
+    # Get Current Time
+    timeCurrent="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
+    # Decide to parse current or supplied date
+    ## Check if time argument empty
+    if [[ -z "$argTime" ]]; then
+       ## T: Time argument empty, use current time
+       timeInput="$timeCurrent";
+    else
+       ## F: Time argument exists, validate time
+       if date --date="$argTime" 1>/dev/null 2>&1; then
+           ### T: Time argument is valid; use it
+           timeInput="$argTime";
+       else
+           ### F: Time argument not valid; exit
+           yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+       fi
+    fi
+    # Construct and deliver separator-les date string    
+    dateCurrentShort="$(date -d "$timeInput" +%Y%m%d)"; # Produce separator-less current date with resolution 1 day.
+    echo "$dateCurrentShort";
 } # Get YYYYmmdd
 timeDuration(){
 } # Get YYYYmmdd
 timeDuration(){
-    # Desc: Output approximate time duration string before given time (default:current date)
+    # Desc: Given seconds, output ISO-8601 duration string
     # Ref/Attrib: ISO-8601:2004(E), Â§4.4.4.2 Representations of time intervals by duration and context information
     # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), Â§2.2.1.2)
     # Ref/Attrib: ISO-8601:2004(E), Â§4.4.4.2 Representations of time intervals by duration and context information
     # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), Â§2.2.1.2)
-    # Usage: timeDuration [arg1] ([arg2])
+    # Usage: timeDuration [1:seconds] ([2:precision])
+    # Version: 1.0.4
     # Input: arg1: seconds as base 10 integer >= 0  (ex: 3601)
     #        arg2: precision level (optional; default=2)
     # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
     # Input: arg1: seconds as base 10 integer >= 0  (ex: 3601)
     #        arg2: precision level (optional; default=2)
     # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
+    #         exit code 0: success
+    #         exit code 1: error_input
+    #         exit code 2: error_unknown
     # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
     # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
-    # Depends: date 8 (gnucoreutils)
-    local returnState fullHours fullMinutes fullSeconds;
-    ARG1="$1";
-    ARG2="$2";
+    # Depends: date 8, bash 5, yell,
+    local argSeconds argPrecision precision returnState remainder
+    local fullYears fullMonths fullDays fullHours fullMinutes fullSeconds
+    local hasYears hasMonths hasDays hasHours hasMinutes hasSeconds
+    local witherPrecision output
+    local displayYears displayMonths displayDays displayHours displayMinutes displaySeconds
+    
+    argSeconds="$1"; # read arg1 (seconds)
+    argPrecision="$2"; # read arg2 (precision)
     precision=2; # set default precision
     precision=2; # set default precision
-    returnState="true"; # set default return state
 
     # Check that between one and two arguments is supplied
     if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
        yell "ERROR:Invalid number of arguments:$# . Exiting.";
 
     # Check that between one and two arguments is supplied
     if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
        yell "ERROR:Invalid number of arguments:$# . Exiting.";
-       returnState="ERROR_INPUT"; fi
+       returnState="error_input"; fi
 
 
-    # Check that arg1 provided
+    # Check that argSeconds provided
     if [[ $# -ge 1 ]]; then
     if [[ $# -ge 1 ]]; then
-       # Check that arg1 is a positive integer
-       if [[ "$ARG1" =~ ^[[:digit:]]+$ ]]; then
-           arg1Valid="true";
+       ## Check that argSeconds is a positive integer
+       if [[ "$argSeconds" =~ ^[[:digit:]]+$ ]]; then
+           :
        else
        else
-           yell "ERROR:ARG1 not a digit.";
-           returnState="ERROR_INPUT";
-           arg1Valid="false";
+           yell "ERROR:argSeconds not a digit.";
+           returnState="error_input";
        fi
     else
        yell "ERROR:No argument provided. Exiting.";
        exit 1;
     fi
 
        fi
     else
        yell "ERROR:No argument provided. Exiting.";
        exit 1;
     fi
 
-    # Consider whether arg2 was provided
+    # Consider whether argPrecision was provided
     if  [[ $# -eq 2 ]]; then
     if  [[ $# -eq 2 ]]; then
-       # Check that the second arg is a positive integer
-       if [[ "$ARG2" =~ ^[[:digit:]]+$ ]] && [[ "ARG2" -gt 0 ]]; then
-       arg2Valid="true";
-       precision="$ARG2";
+       # Check that argPrecision is a positive integer
+       if [[ "$argPrecision" =~ ^[[:digit:]]+$ ]] && [[ "$argPrecision" -gt 0 ]]; then
+       precision="$argPrecision";
        else
        else
-           yell "ERROR:ARG2 not a positive integer. (is $ARG2 ). Leaving early.";
-           returnState="ERROR_INPUT";
-           arg2Valid="false";
+           yell "ERROR:argPrecision not a positive integer. (is $argPrecision ). Leaving early.";
+           returnState="error_input";
        fi;
     else
        fi;
     else
-       arg2Valid="false";
+       :
     fi;
     
     fi;
     
-    remainder="$ARG1" ; # seconds
+    remainder="$argSeconds" ; # seconds
     ## Calculate full years Y, update remainder
     fullYears=$(( remainder / (365*24*60*60) ));
     remainder=$(( remainder - (fullYears*365*24*60*60) ));
     ## Calculate full years Y, update remainder
     fullYears=$(( remainder / (365*24*60*60) ));
     remainder=$(( remainder - (fullYears*365*24*60*60) ));
@@ -491,46 +543,49 @@ timeDuration(){
     fi;
     if $witherPrecision; then ((precision--)); fi;
 
     fi;
     if $witherPrecision; then ((precision--)); fi;
 
-
-
     ## Determine whether or not the "T" separator is needed to separate date and time elements
     if ( $displayHours || $displayMinutes || $displaySeconds); then
        displayDateTime="true"; else displayDateTime="false"; fi
     
     ## Construct duration output string
     ## Determine whether or not the "T" separator is needed to separate date and time elements
     if ( $displayHours || $displayMinutes || $displaySeconds); then
        displayDateTime="true"; else displayDateTime="false"; fi
     
     ## Construct duration output string
-    OUTPUT="P"
+    output="P"
     if $displayYears; then
     if $displayYears; then
-       OUTPUT=$OUTPUT$fullYears"Y"; fi
+       output=$output$fullYears"Y"; fi
     if $displayMonths; then
     if $displayMonths; then
-       OUTPUT=$OUTPUT$fullMonths"M"; fi
+       output=$output$fullMonths"M"; fi
     if $displayDays; then
     if $displayDays; then
-       OUTPUT=$OUTPUT$fullDays"D"; fi
+       output=$output$fullDays"D"; fi
     if $displayDateTime; then
     if $displayDateTime; then
-       OUTPUT=$OUTPUT"T"; fi
+       output=$output"T"; fi
     if $displayHours; then
     if $displayHours; then
-       OUTPUT=$OUTPUT$fullHours"H"; fi
+       output=$output$fullHours"H"; fi
     if $displayMinutes; then
     if $displayMinutes; then
-       OUTPUT=$OUTPUT$fullMinutes"M"; fi
+       output=$output$fullMinutes"M"; fi
     if $displaySeconds; then
     if $displaySeconds; then
-       OUTPUT=$OUTPUT$fullSeconds"S"; fi
+       output=$output$fullSeconds"S"; fi
 
     ## Output duration string to stdout
 
     ## Output duration string to stdout
-    if [[ "$returnState" = "true" ]]; then echo "$OUTPUT"; fi
+    echo "$output" && returnState="true";
 
     #===Determine function return code===
     if [ "$returnState" = "true" ]; then
        return 0;
 
     #===Determine function return code===
     if [ "$returnState" = "true" ]; then
        return 0;
-    else
-       echo "$returnState" 1>&2;
+    elif [ "$returnState" = "error_input" ]; then
+       yell "ERROR:input";
        return 1;
        return 1;
+    else
+       yell "ERROR:Unknown";
+       return 2;
     fi
 
 } # Get duration (ex: PT10M4S )
 displayMissing() {
     # Desc: Displays missing apps, files, and dirs
     # Usage: displayMissing
     fi
 
 } # Get duration (ex: PT10M4S )
 displayMissing() {
     # Desc: Displays missing apps, files, and dirs
     # Usage: displayMissing
+    # Version 0.1.0
     # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
     # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
-    # Output: stderr messages
+    # Output: stderr: messages indicating missing apps, file, or dirs
+    # Depends: bash 5, checkAppFileDir()
     #==BEGIN Display errors==
     #===BEGIN Display Missing Apps===
     missingApps="Missing apps  :"
     #==BEGIN Display errors==
     #===BEGIN Display Missing Apps===
     missingApps="Missing apps  :"
@@ -582,15 +637,15 @@ displayMissing() {
 
     #==END Display errors==
 } # Display missing apps, files, dirs
 
     #==END Display errors==
 } # Display missing apps, files, dirs
-setScriptTTL() {
-    #Desc: Sets script TTL
-    #Usage: setScriptTTL arg1
-    #Input: arg1: "day" or "hour"
-    #Output: scriptTTL
-    #Depends: timeUntilNextHour or timeUntilNextDay
-    local ARG1
-    ARG1="$1"
-    if [[ "$ARG1" = "day" ]]; then
+magicSetScriptTTL() {
+    #Desc: Sets script_TTL seconds from provided time_element string argument
+    #Usage: magicSetScriptTTL [str time_element]
+    #Input: arg1: string (Ex: scriptTTL_TE; "day" or "hour")
+    #Output: var: scriptTTL (integer seconds)
+    #Depends: timeUntilNextHour, timeUntilNextDay
+    local argTimeElement
+    argTimeElement="$1"
+    if [[ "$argTimeElement" = "day" ]]; then
            # Set script lifespan to end at start of next day
        if ! scriptTTL="$(timeUntilNextDay)"; then
            if [[ "$scriptTTL" -eq 0 ]]; then
            # Set script lifespan to end at start of next day
        if ! scriptTTL="$(timeUntilNextDay)"; then
            if [[ "$scriptTTL" -eq 0 ]]; then
@@ -599,7 +654,7 @@ setScriptTTL() {
            yell "ERROR: timeUntilNextDay exit code $?"; exit 1;
            fi;
        fi;
            yell "ERROR: timeUntilNextDay exit code $?"; exit 1;
            fi;
        fi;
-    elif [[ "$ARG1" = "hour" ]]; then
+    elif [[ "$argTimeElement" = "hour" ]]; then
        # Set script lifespan to end at start of next hour
        if ! scriptTTL="$(timeUntilNextHour)"; then
            if [[ "$scriptTTL" -eq 0 ]]; then
        # Set script lifespan to end at start of next hour
        if ! scriptTTL="$(timeUntilNextHour)"; then
            if [[ "$scriptTTL" -eq 0 ]]; then
@@ -609,171 +664,691 @@ setScriptTTL() {
            fi;
        fi;
     else
            fi;
        fi;
     else
-       yell "ERROR:Invalid argument for setScriptTTL function."; exit 1;
+       yell "ERROR:Invalid argument for setScriptTTL function:$argTimeElement"; exit 1;
     fi
 } # Seconds until next (day|hour).
     fi
 } # Seconds until next (day|hour).
-main() {
-    processArguments "$@" # Process arguments.
-    
-    # Determine working directory
-    ## Set DIR_TMP_PARENT to user-specified value if specified
-    if [[ "$OPTION_TMPDIR" = "true" ]]; then
-           if [[ -d "$TMP_DIR_PRIORITY" ]]; then
-           DIR_TMP_PARENT="$OPTION_TMPDIR"; 
+checkMakeTar() {
+    # Desc: Checks that a valid tar archive exists, creates one otherwise
+    # Usage: checkMakeTar [ path ]
+    # Version: 1.0.2
+    # Input: arg1: path of tar archive
+    # Output: exit code 0 : tar readable
+    #         exit code 1 : tar missing; created
+    #         exit code 2 : tar not readable; moved; replaced
+    # Depends: bash 5, date 8, tar 1, try()
+    local pathTar returnFlag0 returnFlag1 returnFlag2
+    pathTar="$1";
+
+    # Check if file is a valid tar archive
+    if tar --list --file="$pathTar" 1>/dev/null 2>&1; then
+       ## T1: return success
+       returnFlag0="tar valid";
+    else
+       ## F1: Check if file exists
+       if [[ -f "$pathTar" ]]; then
+           ### T: Rename file
+           try mv "$pathTar" "$pathTar""--broken--""$(date +%Y%m%dT%H%M%S)" && \
+               returnFlag1="tar moved";
        else
        else
-           yell "WARNING:Specified temporary working directory not valid:$OPTION_TMP_DIR";
-           exit 1;
-       fi
-    fi
+           ### F: -
+           :
+       fi;
+       ## F2: Create tar archive, return 0
+       try tar --create --file="$pathTar" --files-from=/dev/null && \
+           returnFlag2="tar created";
+    fi;
+    
+    # Determine function return code
+    if [[ "$returnFlag0" = "tar valid" ]]; then
+       return 0;
+    elif [[ "$returnFlag2" = "tar created" ]] && ! [[ "$returnFlag1" = "tar moved" ]]; then
+       return 1; # tar missing so created
+    elif [[ "$returnFlag2" = "tar created" ]] && [[ "$returnFlag1" = "tar moved" ]]; then
+       return 2; # tar not readable so moved; replaced
+    fi;
+} # checks if arg1 is tar; creates one otherwise
+appendArgTar(){
+    # Desc: Writes first argument to temporary file with arguments as options, then appends file to tar
+    # Usage: appendArgTar "$(echo "Data to be written.")" [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
+    # Version: 1.0.6
+    # Input: arg1: data to be written
+    #        arg2: file name of file to be inserted into tar
+    #        arg3: tar archive path (must exist first)
+    #        arg4: temporary working dir
+    #        arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+    # Output: file written to disk
+    # Example: decrypt multiple large files in parallel
+    #          appendArgTar "$(cat /tmp/largefile1.gpg)" "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendArgTar "$(cat /tmp/largefile2.gpg)" "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendArgTar "$(cat /tmp/largefile3.gpg)" "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+    # Depends: bash 5, tar 1, yell()
+    # Ref/Attrib: Using 'eval' to construct command strings https://askubuntu.com/a/476533
+
+    local fn fileName tarPath tmpDir cmd0 cmd1 cmd2 cmd3 cmd4
+
+    # Save function name
+    fn="${FUNCNAME[0]}";
+    #yell "DEBUG:STATUS:$fn:Finished appendArgTar()."
+    
+    # Set file name
+    if ! [ -z "$2" ]; then fileName="$2"; else yell "ERROR:$fn:Not enough arguments."; exit 1; fi
+    
+    # Check tar path is a file
+    if [ -f "$3" ]; then tarPath="$3"; else yell "ERROR:$fn:Tar archive arg not a file."; exit 1; fi
+       
+    # Check temp dir arg
+    if ! [ -z "$4" ]; then tmpDir="$4"; else yell "ERROR:$fn:No temporary working dir set."; exit 1; fi
+    
+    # Set command strings
+    if ! [ -z "$5" ]; then cmd1="$5"; else cmd1="cat "; fi # command string 1
+    if ! [ -z "$6" ]; then cmd2="$6"; else cmd2="cat "; fi # command string 2
+    if ! [ -z "$7" ]; then cmd3="$7"; else cmd3="cat "; fi # command string 3
+    if ! [ -z "$8" ]; then cmd4="$8"; else cmd4="cat "; fi # command string 4
+
+    # Input command
+    cmd0="echo \"\$1\""
+
+    # # Debug
+    # yell "DEBUG:STATUS:$fn:cmd0:$cmd0"
+    # yell "DEBUG:STATUS:$fn:cmd1:$cmd1"
+    # yell "DEBUG:STATUS:$fn:cmd2:$cmd2"
+    # yell "DEBUG:STATUS:$fn:cmd3:$cmd3"
+    # yell "DEBUG:STATUS:$fn:cmd4:$cmd4"
+    # yell "DEBUG:STATUS:$fn:fileName:$fileName"
+    # yell "DEBUG:STATUS:$fn:tarPath:$tarPath"
+    # yell "DEBUG:STATUS:$fn:tmpDir:$tmpDir"
+    
+    # Write to temporary working dir
+    eval "$cmd0 | $cmd1 | $cmd2 | $cmd3 | $cmd4" > "$tmpDir"/"$fileName";
+
+    # Append to tar
+    try tar --append --directory="$tmpDir" --file="$tarPath" "$fileName";
+    #yell "DEBUG:STATUS:$fn:Finished appendArgTar()."
+} # Append Bash var to file appended to Tar archive
+appendFileTar(){
+    # Desc: Processes first file and then appends to tar
+    # Usage: appendFileTar [file path] [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
+    # Version: 1.0.3
+    # Input: arg1: path of file to be (processed and) written
+    #        arg2: name to use for file inserted into tar
+    #        arg3: tar archive path (must exist first)
+    #        arg4: temporary working dir
+    #        arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+    # Output: file written to disk
+    # Example: decrypt multiple large files in parallel
+    #          appendFileTar /tmp/largefile1.gpg "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendFileTar /tmp/largefile2.gpg "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendFileTar /tmp/largefile3.gpg "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+    # Depends: bash 5, tar 1, yell()
+
+    local fn fileName tarPath tmpDir
+
+    # Save function name
+    fn="${FUNCNAME[0]}";
+    #yell "DEBUG:STATUS:$fn:Finished appendFileTar()."
+    
+    # Set file name
+    if ! [ -z "$2" ]; then fileName="$2"; else yell "ERROR:$fn:Not enough arguments."; exit 1; fi
+    # Check tar path is a file
+    if [ -f "$3" ]; then tarPath="$3"; else yell "ERROR:$fn:Tar archive arg not a file:$3"; exit 1; fi
+    # Check temp dir arg
+    if ! [ -z "$4" ]; then tmpDir="$4"; else yell "ERROR:$fn:No temporary working dir set."; exit 1; fi
+    # Set command strings
+    if ! [ -z "$5" ]; then cmd1="$5"; else cmd1="cat "; fi # command string 1
+    if ! [ -z "$6" ]; then cmd2="$6"; else cmd2="cat "; fi # command string 2
+    if ! [ -z "$7" ]; then cmd3="$7"; else cmd3="cat "; fi # command string 3
+    if ! [ -z "$8" ]; then cmd4="$8"; else cmd4="cat "; fi # command string 4
 
 
-    ## Set DIR_TMP_PARENT to default or fallback otherwise
-    if [[ -d "$DIR_TMP_DEFAULT" ]]; then
-       DIR_TMP_PARENT="$DIR_TMP_DEFAULT";
-    elif [[ -d /tmp ]]; then
-       yell "WARNING:/dev/shm not available. Falling back to /tmp .";
-       DIR_TMP_PARENT="/tmp";
+    # Input command string
+    cmd0="cat \"\$1\""
+    
+    # # Debug
+    # yell "DEBUG:STATUS:$fn:cmd0:$cmd0"
+    # yell "DEBUG:STATUS:$fn:cmd1:$cmd1"
+    # yell "DEBUG:STATUS:$fn:cmd2:$cmd2"
+    # yell "DEBUG:STATUS:$fn:cmd3:$cmd3"
+    # yell "DEBUG:STATUS:$fn:cmd4:$cmd4"
+    # yell "DEBUG:STATUS:$fn:fileName:$fileName"
+    # yell "DEBUG:STATUS:$fn:tarPath:$tarPath"
+    # yell "DEBUG:STATUS:$fn:tmpDir:$tmpDir"
+    
+    # Write to temporary working dir
+    eval "$cmd0 | $cmd1 | $cmd2 | $cmd3 | $cmd4" > "$tmpDir"/"$fileName";
+
+    # Append to tar
+    try tar --append --directory="$tmpDir" --file="$tarPath" "$fileName";
+    #yell "DEBUG:STATUS:$fn:Finished appendFileTar()."
+} # Append file to Tar archive
+checkAgePubkey() {
+    # Desc: Checks if string is an age-compatible pubkey
+    # Usage: checkAgePubkey [str pubkey]
+    # Version: 0.1.2
+    # Input: arg1: string
+    # Output: return code 0: string is age-compatible pubkey
+    #         return code 1: string is NOT an age-compatible pubkey
+    #         age stderr (ex: there is stderr if invalid string provided)
+    # Depends: age (v0.1.0-beta2; https://github.com/FiloSottile/age/releases/tag/v1.0.0-beta2 )
+    
+    argPubkey="$1";
+    
+    if echo "test" | age -a -r "$argPubkey" 1>/dev/null; then
+       return 0;
     else
     else
-       yell "ERROR:No valid working directory available. Exiting.";
-       exit 1;
-    fi
+       return 1;
+    fi;
+} # Check age pubkey
+validateInput() {
+    # Desc: Validates Input
+    # Usage: validateInput [str input] [str input type]
+    # Version: 0.3.1
+    # Input: arg1: string to validate
+    #        arg2: string specifying input type (ex:"ssh_pubkey")
+    # Output: return code 0: if input string matched specified string type
+    # Depends: bash 5, yell()
+
+    local fn argInput argType
+
+    # Save function name
+    fn="${FUNCNAME[0]}";
+
+    # Process arguments
+    argInput="$1";
+    argType="$2";
+    if [[ $# -gt 2 ]]; then yell "ERROR:$0:$fn:Too many arguments."; exit 1; fi;
+
+    # Check for blank
+    if [[ -z "$argInput" ]]; then return 1; fi
+    
+    # Define input types
+    ## ssh_pubkey
+    ### Check for alnum/dash base64 (ex: "ssh-rsa AAAAB3NzaC1yc2EAAA")
+    if [[ "$argType" = "ssh_pubkey" ]]; then
+       if [[ "$argInput" =~ ^[[:alnum:]-]*[\ ]*[[:alnum:]+/=]*$ ]]; then
+           return 0; fi; fi;
+
+    ## age_pubkey
+    ### Check for age1[:bech32:]
+    if [[ "$argType" = "age_pubkey" ]]; then
+       if [[ "$argInput" =~ ^age1[qpzry9x8gf2tvdw0s3jn54khce6mua7l]*$ ]]; then
+           return 0; fi; fi
+
+    ## integer
+    if [[ "$argType" = "integer" ]]; then
+       if [[ "$argInput" =~ ^[[:digit:]]*$ ]]; then
+           return 0; fi; fi;
+
+    ## time element (year, month, week, day, hour, minute, second)
+    if [[ "$argType" = "time_element" ]]; then
+       if [[ "$argInput" = "year" ]] || \
+              [[ "$argInput" = "month" ]] || \
+              [[ "$argInput" = "week" ]] || \
+              [[ "$argInput" = "day" ]] || \
+              [[ "$argInput" = "hour" ]] || \
+              [[ "$argInput" = "minute" ]] || \
+              [[ "$argInput" = "second" ]]; then
+           return 0; fi; fi;
+    
+    # Return error if no condition matched.
+    return 1;
+} # Validates strings
+timeEpochNS() {
+    # Desc: Get epoch nanoseconds
+    # Usage: timeEpochNS
+    # Version 0.2.3
+    # Input: arg1: 'date'-parsable timestamp string (optional)
+    # Output: Nanoseconds since 1970-01-01
+    # Depends: date 8, cut 8, yell()
+    # Ref/Attrib: Force base 10 Bash arith with '10#'. https://stackoverflow.com/a/24777667
+    local argTime timeCurrent timeInput timeEpochFloat timeEpochInt
+    local timeEpochNsFrac timeEpochNs
+
+    argTime="$1";
+
+    # Get Current Time
+    timeCurrent="$(date --iso-8601=ns)"; # Produce `date`-parsable current timestamp with resolution of 1 nanosecond.
+
+    # Decide to parse current or supplied time
+    ## Check if time argument empty
+    if [[ -z "$argTime" ]]; then
+       ## T: Time argument empty, use current time
+       timeInput="$timeCurrent";
+    else
+       ## F: Time argument exists, validate time
+       if date --date="$argTime" 1>/dev/null 2>&1; then
+           ### T: Time argument is valid; use it
+           timeInput="$argTime";
+       else
+           ### F: Time argument not valid; exit
+           yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+       fi;
+    fi;
+    # Construct and deliver nanoseconds since 1970-01-01    
+    timeEpochFloat="$(date --date="$timeInput" +%s.%N)"; # Save ssss.NNNNNNNNN
+    timeEpochInt="$(echo "$timeEpochFloat" | cut -d. -f1)"; # Get ssss
+    timeEpochNsFrac="$(echo "$timeEpochFloat" | cut -d. -f2)"; # Get NNNNNNNNN
+    timeEpochNs="$(( (10#"$timeEpochInt" * 10**9) + (10#"$timeEpochNsFrac") ))";
+    echo "$timeEpochNs";
+} # Nanoseconds since 1970-01-01
+magicBufferSleepPID() {
+    # Desc: Compensates for lag so buffer rounds start every bufferTTL seconds
+    # Input: vars: bufferTTL, errReset
+    # # Input: array: errorHistory errResetx10e3
+    # Output: vars: bufferTTL_AdjFloat
+    # Re/Attrib: https://en.wikipedia.org/wiki/PID_controller#Standard_versus_parallel_(ideal)_form
+    local buffer_ttl_ns k_p t_i t_d
+    local timeBufferStartNS timeBufferStartNSExp errNS errReset errRate
+    local adj buffer_ttl_adj_ns buffer_ttl_adj_int buffer_ttl_adj_floatfrac
+    # local errNSx10e3 errResetx10e3 errRatex10e3
+    # local errorHistorySize
+    
+    # ## Define errorHistorySize
+    # errorHistorySize=100;
+    ## Define bufferTTL in nanoseconds
+    buffer_ttl_ns=$((bufferTTL * 10**9)) && vbm "buffer_ttl_ns:$buffer_ttl_ns";
 
 
-    ## Set DIR_TMP using DIR_TMP_PARENT and nonce (SCRIPT_TIME_START)
-    DIR_TMP="$DIR_TMP_PARENT"/"$SCRIPT_TIME_START""..bkgpslog" && vbm "DEBUG:Set DIR_TMP to:$DIR_TMP"; # Note: removed at end of main().
+    ### PID Control factors
+    k_p=1; # Gain for compensating buffer round lag
+    t_i="$(((4)*buffer_ttl_ns/(1)))"; # Consider this number of past nanoseconds to eliminate error
+    t_d="$(((1)*buffer_ttl_ns/(1)))"; # Predict value this number of nanoseconds into the future
     
     
-    # Set output encryption and compression option strings
-    if [[ "$OPTION_ENCRYPT" = "true" ]]; then # Check if encryption option active.
+    # Calculate Error, errNS, in nanoseconds
+    ## Get current time
+    timeBufferStartNS="$(timeEpochNS)" && vbm "timeBufferStartNS   :$timeBufferStartNS";
+    ## Calculate expected time (from start time, current buffer round number, nominal bufferTTL)
+    timeBufferStartNSExp="$(( (timeBufferFirstNS) + (buffer_ttl_ns * bufferRound) ))" && vbm "timeBufferStartNSExp:$timeBufferStartNSExp";
+    ## Calculate error (diff between timeBufferStartNSExp and timeBufferStartNS; usually negative)
+    errNS="$(( timeBufferStartNSExp - timeBufferStartNS ))" && vbm "errNS:$errNS";
+#    errNSx10e3="$((errNS*10**3))" && vbm "errNSx10e3:$errNSx10e3";
+    # ## Append error to errorHistory
+    # errorHistory+=("errNS");
+    # ### Trim errorHistory array if over errorHistorySize
+    # while [[ "${#errorHistory[@]}" -gt "errorHistorySize" ]]; then do
+    #  unset "errorHistory[0]"; # remove oldest entry, creating sparse array
+    #  errorHistory=("${errorHistory[@]}"); # reindex sparse array
+    #  vbm "STATUS:Trimmed errorHistory array. Entry count:${#errorHistory[@]}";
+    # done;
+
+    # Calculate errReset in nanoseconds^2
+    ## errReset = int(errHistory(t),wrt(delta_buffer_ttl))
+    ## Integrate errorHistory with respect to time
+    # for value in "${errorHistory[@]}"; do
+    #  errReset=$(( errReset + ( value*buffer_ttl_ns ) ));
+    # done;
+    vbm "errReset(orig):$errReset"
+    errReset="$(( (errReset + (errNS*buffer_ttl_ns)) ))" && vbm "errReset(post):$errReset";
+#    errResetx10e3="$(( ( errResetx10e3 + ( errNSx10e3 * buffer_ttl_ns ) )*10**3 ))" && vbm "errResetx10e3:$errResetx10e3";
+
+    # Calculate errRate in nanoseconds per nanosecond
+    errRate="$(( errNS / buffer_ttl_ns ))" && vbm "errRate:$errRate";
+#    errRatex10e3="$(( ( errNSx10e3 ) / buffer_ttl_ns ))" && vbm "errRatex10e3:$errRatex10e3";
+
+    # Debug
+    vbm "errNS       :$errNS";
+    vbm "errResetTerm:$((errReset/t_i))";
+    vbm "errRateTerm :$((errRate*t_d))";
+    
+    # Calculate PID control signal
+    ## adj = k_p * (errNS + errReset/t_i + errRate*t_d)
+    adj="$(( k_p*(errNS + errReset/t_i + errRate*t_d) ))" && vbm "adj:$adj";
+#    adj="$((k_p*(errNSx10e3 + (errResetx10e3/t_i) + (errRatex10e3*t_d) )/(10**3)))" && vbm "adj:$adj";
+
+    # Calculate bufferTTL_AdjFloat from adj (ns)
+    ## Calculate buffer_ttl_adj in nanoseconds (buffer_ttl_adj_ns = buffer_ttl_ns + adj)
+    buffer_ttl_adj_ns="$((buffer_ttl_ns + adj))" && vbm "buffer_ttl_adj_ns:$buffer_ttl_adj_ns";
+    ## Calculate integer seconds
+    buffer_ttl_adj_int="$((buffer_ttl_adj_ns/(10**9)))" && vbm "buffer_ttl_adj_int:$buffer_ttl_adj_int";
+    ### Catch negative integer seconds, set minimum of bufferTTL/10 seconds
+    if [[ "$buffer_ttl_adj_int" -le "$((bufferTTL/10))" ]]; then
+       buffer_ttl_adj_int="$((bufferTTL/10))";
+       yell "WARNING:Buffer lag adjustment yielded negative seconds.";
+    fi;
+    ## Calculate nanosecond remainder
+    ### Remove integer
+    buffer_ttl_adj_floatfrac="$((buffer_ttl_adj_ns - (buffer_ttl_adj_int*(10**9)) ))" && vbm "buffer_ttl_adj_floatfrac:$buffer_ttl_adj_floatfrac";
+    ### Calc absolute value of fraction (by removing '-' if present; see https://stackoverflow.com/a/47240327
+    buffer_ttl_adj_floatfrac="${buffer_ttl_adj_floatfrac#-}" && vbm "buffer_ttl_adj_floatfrac:$buffer_ttl_adj_floatfrac";
+    ## Form float bufferTTL_AdjFloat (function output)
+    bufferTTL_AdjFloat="$buffer_ttl_adj_int"."$buffer_ttl_adj_floatfrac" && vbm "bufferTTL_AdjFloat:$bufferTTL_AdjFloat";
+    vbm "STATUS:Calculated adjusted bufferTTL (seconds):$bufferTTL_AdjFloat";
+} # Calc bufferTTL_AdjFloat so buffer starts every bufferTTL seconds
+magicWriteVersion() {
+    # Desc: Appends time-stamped VERSION to pathout_tar
+    # Usage: magicWriteVersion
+    # Input: vars: pathout_tar, dir_tmp
+    # Input: array: recPubKeysValid
+    # Input: scriptVersion, scriptURL, ageVersion, ageURL, scriptHostname
+    # Output: appends tar (pathout_tar)
+    # Depends: dateTimeShort, appendArgTar
+    local fileoutVersion contentVersion pubKeyIndex
+    
+    # Set VERSION file name
+    fileoutVersion="$(dateTimeShort)..VERSION";
+
+    # Gather VERSION data in contentVersion
+    contentVersion="scriptVersion=$scriptVersion";
+    #contentVersion="$contentVersion""\\n";
+    contentVersion="$contentVersion""\\n""scriptName=$scriptName";
+    contentVersion="$contentVersion""\\n""scriptURL=$scriptURL";
+    contentVersion="$contentVersion""\\n""ageVersion=$ageVersion";
+    contentVersion="$contentVersion""\\n""ageURL=$ageURL";
+    contentVersion="$contentVersion""\\n""date=$(date --iso-8601=seconds)";
+    contentVersion="$contentVersion""\\n""hostname=$scriptHostname";
+    ## Add list of recipient pubkeys
+    for pubkey in "${recPubKeysValid[@]}"; do
+       ((pubKeyIndex++))
+       contentVersion="$contentVersion""\\n""PUBKEY_$pubKeyIndex=$pubkey";
+    done
+    ## Process newline escapes
+    contentVersion="$(echo -e "$contentVersion")"
+
+    # Write contentVersion as file fileoutVersion and write-append to pathout_tar
+    appendArgTar "$contentVersion" "$fileoutVersion" "$pathout_tar" "$dir_tmp";
+} # bkgpslog: write version data to pathout_tar via appendArgTar()
+magicGatherWriteBuffer() {
+    # Desc: bkgpslog-specific meta function for writing data to dir_tmp then appending each file to pathout_tar
+    # Inputs: vars: pathout_tar, cmd_conv_{nmea,gpx,kml}, cmd_{compress,encrypt} dir_tmp,
+    # Inputs: vars: bufferTTL bufferTTL_STR scriptHostname cmd_compress_suffix cmd_encrypt_suffix
+    # Output: file: (pathout_tar)
+    # Depends: tar 1, date 8, sleep 8, yell(), try(), vbm(), appendArgTar(), checkMakeTar()
+    # Depends: magicWriteVersion(), appendFileTar()
+    local fn pathoutBuffer timeBufferStartLong timeBufferStart fileoutBasename
+    local fileout_nmea fileout_gpx fileout_kml pathout_nmea pathout_gpx pathout_kml pathout_tar
+
+    # Debug:Get function name
+    fn="${FUNCNAME[0]}";
+
+    vbm "DEBUG:STATUS:$fn:Started magicGatherWriteBuffer().";
+    
+    # Create buffer file with unique name
+    pathoutBuffer="$dir_tmp/buffer$SECONDS" && vbm "pathoutBuffer:$pathoutBuffer";
+    # Fill buffer
+    timeout "$bufferTTL"s gpspipe -r -o "$pathoutBuffer" ;
+    timeBufferStartLong="$(date --date="$bufferTTL seconds ago" --iso-8601=seconds)" && vbm "timeBufferStartLong:$timeBufferStartLong";
+    timeBufferStart="$(dateTimeShort "$timeBufferStartLong" )" && vbm "timeBufferStart:$timeBufferStart"; # Note start time
+    # Determine file paths (time is start of buffer period)
+    fileoutBasename="$timeBufferStart""--""$bufferTTL_STR""..""$scriptHostname""_location" && vbm "STATUS:Set fileoutBasename to:$fileoutBasename";
+    ## Files saved to dir_tmp
+    fileout_nmea="$fileoutBasename".nmea"$cmd_compress_suffix""$cmd_encrypt_suffix" && vbm "STATUS:Set fileout_nmea to:$fileout_nmea";
+    fileout_gpx="$fileoutBasename".gpx"$cmd_compress_suffix""$cmd_encrypt_suffix" && vbm "STATUS:Set fileout_gpx to:$fileout_gpx";
+    fileout_kml="$fileoutBasename".kml"$cmd_compress_suffix""$cmd_encrypt_suffix" && vbm "STATUS:Set fileout_kml to:$fileout_kml";
+    pathout_nmea="$dir_tmp"/"$fileout_nmea" && vbm "STATUS:Set pathout_nmea to:$pathout_nmea";
+    pathout_gpx="$dir_tmp"/"$fileout_gpx" && vbm "STATUS:Set pathout_gpx to:$pathout_gpx";
+    pathout_kml="$dir_tmp"/"$fileout_kml" && vbm "STATUS:Set pathout_kml to:$pathout_kml";
+    ## Files saved to disk (dirOut)
+    ### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
+    pathout_tar="$dirOut"/"$(dateShort "$(date --date="$bufferTTL seconds ago" --iso-8601=seconds)")".."$scriptHostname""_location""$cmd_compress_suffix""$cmd_encrypt_suffix".tar && \
+       vbm "STATUS:Set pathout_tar to:$pathout_tar";
+    # DEBUG: check vars
+    vbm "STATUS:fn             :$fn";
+    vbm "STATUS:dir_tmp        :$dir_tmp";
+    vbm "STATUS:pathout_tar    :$pathout_tar";
+    vbm "STATUS:pathout_nmea   :$pathout_nmea";
+    vbm "STATUS:pathout_gpx    :$pathout_gpx";
+    vbm "STATUS:pathout_kml    :$pathout_kml";
+    vbm "STATUS:bufferTTL      :$bufferTTL";
+    vbm "STATUS:pathoutBuffer  :$pathoutBuffer";
+    vbm "STATUS:timeBufferStart:$timeBufferStart";
+    vbm "fileoutBasename      :$fileoutBasename";
+    
+    # Validate pathout_tar as tar.
+    checkMakeTar "$pathout_tar";
+    ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+    vbm "exit status before magicWriteVersion:$?"
+    if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
+
+    # Write bufferBash to pathout_tar
+    wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
+    appendFileTar "$pathoutBuffer" "$fileout_nmea" "$pathout_tar" "$dir_tmp" "$cmd_conv_nmea" "$cmd_compress" "$cmd_encrypt"; # Write NMEA data
+    appendFileTar "$pathoutBuffer" "$fileout_gpx" "$pathout_tar" "$dir_tmp" "$cmd_conv_gpx" "$cmd_compress" "$cmd_encrypt"; # Write GPX file
+    appendFileTar "$pathoutBuffer" "$fileout_kml" "$pathout_tar" "$dir_tmp" "$cmd_conv_kml" "$cmd_compress" "$cmd_encrypt"; # Write KML file
+
+    # Remove secured chunks from dir_tmp
+    rm "$pathoutBuffer" "$pathout_nmea" "$pathout_gpx" "$pathout_kml";
+    vbm "DEBUG:STATUS:$fn:Finished magicGatherWriteBuffer().";
+} # write buffer to disk
+magicParseRecipientDir() {
+    # Desc: Updates recPubKeysValid with pubkeys in dir specified by '-R' option ("recipient directory")
+    # Inputs:  vars: optionRecDir, argRecDir, optionEncrypt
+    #          arry: recPubKeysValid
+    # Outputs: arry: recPubKeysValid
+    # Depends: processArguments,
+    local recipientDir recFileLine updateRecipients 
+    declare -a candRecPubKeysValid
+
+    # Check that '-e' and '-R' set
+    if [[ "$optionEncrypt" = "true" ]] && [[ "$optionRecDir" = "true" ]]; then
+       ### Check that argRecDir is a directory.
+       if [[ -d "$argRecDir" ]]; then
+           recipientDir="$argRecDir" && vbm "STATUS:Recipient watch directory detected:\"$recipientDir\"";
+           #### Initialize variable indicating outcome of pubkey review
+           unset updateRecipients
+           #### Add existing recipients
+           candRecPubKeysValid=("${recPubKeysValidStatic[@]}");
+           #### Parse files in recipientDir
+           for file in "$recipientDir"/*; do
+               ##### Read first line of each file
+               recFileLine="$(head -n1 "$file")" && vbm "STATUS:Checking if pubkey:\"$recFileLine\"";
+               ##### check if first line is a valid pubkey
+               if checkAgePubkey "$recFileLine" && \
+                       ( validateInput "$recFileLine" "ssh_pubkey" || validateInput "$recFileLine" "age_pubkey"); then
+                   ###### T: add candidate pubkey to candRecPubKeysValid
+                   candRecPubKeysValid+=("$recFileLine") && vbm "STATUS:RecDir pubkey is valid pubkey:\"$recFileLine\"";
+               else
+                   ###### F: throw warning;
+                   yell "ERROR:Invalid recipient file detected. Not modifying recipient list."
+                   updateRecipients="false";
+               fi;
+           done
+           #### Write updated recPubKeysValid array to recPubKeysValid if no failure detected
+           if ! [[ "$updateRecipients" = "false" ]]; then
+               recPubKeysValid=("${candRecPubKeysValid[@]}") && vbm "STATUS:Wrote candRecPubkeysValid to recPubKeysValid:\"${recPubKeysValid[*]}\"";
+           fi;
+       else
+           yell "ERROR:$0:Recipient directory $argRecDir does not exist. Exiting."; exit 1;
+       fi;
+    fi;
+    # Handle case if '-R' set but '-e' not set
+    if [[ ! "$optionEncrypt" = "true" ]] && [[ "$optionRecDir" = "true" ]]; then
+       yell "ERROR: \\'-R\\' is set but \\'-e\\' is not set."; fi;
+} # Update recPubKeysValid with argRecDir
+magicParseRecipientArgs() {
+    # Desc: Parses recipient arguments specified by '-r' option
+    # Input:  vars: optionEncrypt, optionRecipients
+    #         arry: argRecPubKeys from processArguments()
+    # Output: vars: cmd_encrypt, cmd_encrypt_suffix
+    #         arry: recPubKeysValid, recPubKeysValidStatic
+    # Depends: checkapp(), checkAgePubkey(), validateInput(), processArguments()
+    local recipients
+
+    # Check if encryption option active.
+    if [[ "$optionEncrypt" = "true" ]] && [[ "$optionRecipients" = "true" ]]; then 
        if checkapp age; then # Check that age is available.
        if checkapp age; then # Check that age is available.
-           for pubkey in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
-               vbm "DEBUG:Testing pubkey string:$pubkey"
-               if echo "butts" | age -a -r "$pubkey" 1>/dev/null; then
-                   # Form age recipient string
-                   recipients="$recipients""-r $pubkey ";
+           for pubkey in "${argRecPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
+               vbm "DEBUG:Testing pubkey string:$pubkey";
+               if checkAgePubkey "$pubkey" && \
+                       ( validateInput "$pubkey" "ssh_pubkey" || validateInput "$pubkey" "age_pubkey"); then
+                   #### Form age recipient string
+                   recipients="$recipients""-r '$pubkey' ";
                    vbm "STATUS:Added pubkey for forming age recipient string:""$pubkey";
                    vbm "DEBUG:recipients:""$recipients";
                    vbm "STATUS:Added pubkey for forming age recipient string:""$pubkey";
                    vbm "DEBUG:recipients:""$recipients";
+                   #### Add validated pubkey to recPubKeysValid array
+                   recPubKeysValid+=("$pubkey") && vbm "DEBUG:recPubkeysValid:pubkey added:$pubkey";
                else
                    yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
                else
                    yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
-               fi
+               fi;
            done
            done
-           vbm "DEBUG:Finished processing recPubKeys array";
-           # Form age command string
-           CMD_ENCRYPT="age ""$recipients ";
-           CMD_ENCRYPT_SUFFIX=".age";
+           vbm "DEBUG:Finished processing argRecPubKeys array";
+           vbm "STATUS:Array of validated pubkeys:${recPubKeysValid[*]}";
+           recPubKeysValidStatic=("${recPubKeysValid[@]}"); # Save static image of pubkeys validated by this function
+
+           ##  Form age command string
+           cmd_encrypt="age ""$recipients " && vbm "cmd_encrypt:$cmd_encrypt";
+           cmd_encrypt_suffix=".age" && vbm "cmd_encrypt_suffix:$cmd_encrypt_suffix";
        else
            yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
        else
            yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
-       fi
+       fi;
     else
     else
-       CMD_ENCRYPT="tee /dev/null ";
-       CMD_ENCRYPT_SUFFIX="";
+       cmd_encrypt="tee /dev/null " && vbm "cmd_encrypt:$cmd_encrypt";
+       cmd_encrypt_suffix="" && vbm "cmd_encrypt_suffix:$cmd_encrypt_suffix";
        vbm "DEBUG:Encryption not enabled."
        vbm "DEBUG:Encryption not enabled."
-    fi
-    if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
+    fi;
+    # Catch case if '-e' is set but '-r' or '-R' is not
+    if [[ "$optionEncrypt" = "true" ]] && [[ ! "$optionRecipients" = "true" ]]; then
+       yell "ERROR:\\'-e\\' set but no \\'-r\\' or \\'-R\\' set."; exit 1; fi;
+    # Catch case if '-r' or '-R' set but '-e' is not
+    if [[ ! "$optionEncrypt" = "true" ]] && [[ "$optionRecipients" = "true" ]]; then
+       yell "ERROR:\\'-r\\' or \\'-R\\' set but \\'-e\\' is not set."; exit 1; fi; 
+} # Populate recPubKeysValid with argRecPubKeys; form encryption cmd string and filename suffix
+magicParseCompressionArg() {
+    # Desc: Parses compression arguments specified by '-c' option
+    # Input:  vars: optionCompress
+    # Output: cmd_compress, cmd_compress_suffix
+    # Depends: checkapp(), vbm(), gzip, 
+    if [[ "$optionCompress" = "true" ]]; then # Check if compression option active
        if checkapp gzip; then # Check if gzip available
        if checkapp gzip; then # Check if gzip available
-           CMD_COMPRESS="gzip ";
-           CMD_COMPRESS_SUFFIX=".gz";
+           cmd_compress="gzip " && vbm "cmd_compress:$cmd_compress";
+           cmd_compress_suffix=".gz" && vbm "cmd_compress_suffix:$cmd_compress_suffix";
        else
            yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
        fi
     else
        else
            yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
        fi
     else
-       CMD_COMPRESS="tee /dev/null ";
-       CMD_COMPRESS_SUFFIX="";
-       vbm "DEBUG:Compression not enabled."
-    fi
+       cmd_compress="tee /dev/null " && vbm "cmd_compress:$cmd_compress";
+       cmd_compress_suffix="" && vbm "cmd_compress_suffix:$cmd_compress_suffix";
+       vbm "DEBUG:Compression not enabled.";
+    fi    
+} # Form compression cmd string and filename suffix
+magicInitWorkingDir() {
+    # Desc: Determine temporary working directory from defaults or user input
+    # Usage: magicInitWorkingDir
+    # Input:  vars: optionTmpDir, argTempDirPriority, dirTmpDefault
+    # Input:  vars: scriptTimeStart
+    # Output: vars: dir_tmp
+    # Depends: processArguments(), vbm(), yell()
+    # Parse '-t' option (user-specified temporary working dir)
+    ## Set dir_tmp_parent to user-specified value if specified
+    local dir_tmp_parent
+    
+    if [[ "$optionTmpDir" = "true" ]]; then
+       if [[ -d "$argTempDirPriority" ]]; then
+           dir_tmp_parent="$argTempDirPriority"; 
+       else
+           yell "WARNING:Specified temporary working directory not valid:$argTempDirPriority";
+           exit 1; # Exit since user requires a specific temp dir and it is not available.
+       fi;
+    else
+    ## Set dir_tmp_parent to default or fallback otherwise
+       if [[ -d "$dirTmpDefault" ]]; then
+           dir_tmp_parent="$dirTmpDefault";
+       elif [[ -d /tmp ]]; then
+           yell "WARNING:$dirTmpDefault not available. Falling back to /tmp .";
+           dir_tmp_parent="/tmp";
+       else
+           yell "ERROR:No valid working directory available. Exiting.";
+           exit 1;
+       fi
+    fi;
+    ## Set dir_tmp using dir_tmp_parent and nonce (scriptTimeStart)
+    dir_tmp="$dir_tmp_parent"/"$scriptTimeStart""..bkgpslog" && vbm "DEBUG:Set dir_tmp to:$dir_tmp"; # Note: removed at end of main().
+} # Sets working dir
+magicParseCustomTTL() {
+    # Desc: Set user-specified TTLs for buffer and script
+    # Input: vars: argCustomBufferTTL (integer), argCustomScriptTTL_TE (string)
+    # Input: vars: optionCustomBufferTTL, optionCustomScriptTTL_TE
+    # Input: vars: bufferTTL (integer), scriptTTL_TE (string)
+    # Output: bufferTTL (integer), scriptTTL_TE (string)
+    # Depends validateInput(), showUsage(), yell
+
+    # React to '-b, --buffer-ttl' option
+    if [[ "$optionCustomBufferTTL" = "true" ]]; then
+       ## T: Check if argCustomBufferTTL is an integer
+       if validateInput "$argCustomBufferTTL" "integer"; then
+           ### T: argCustomBufferTTL is an integer
+           bufferTTL="$argCustomBufferTTL" && vbm "Custom bufferTTL from -b:$bufferTTL";
+       else
+           ### F: argcustomBufferTTL is not an integer
+           yell "ERROR:Invalid integer argument for custom buffer time-to-live."; showUsage; exit 1;
+       fi;
+       ## F: do not change bufferTTL
+    fi;
+    
+    # React to '-B, --script-ttl' option
+    if [[ "$optionCustomScriptTTL_TE" = "true" ]]; then
+       ## T: Check if argCustomScriptTTL is a time element (ex: "day", "hour")
+       if validateInput "$argCustomScriptTTL" "time_element"; then
+           ### T: argCustomScriptTTL is a time element
+           scriptTTL_TE="$argCustomScriptTTL" && vbm "Custom scriptTTL_TE from -B:$scriptTTL_TE";
+       else
+           ### F: argcustomScriptTTL is not a time element
+           yell "ERROR:Invalid time element argument for custom script time-to-live."; showUsage; exit 1;
+       fi;
+       ## F: do not change scriptTTL_TE
+    fi;    
+} # Sets custom script or buffer TTL if specified
 
 
-    # Check that critical apps and dirs are available, displag missing ones.
-    if ! checkapp gpspipe tar && ! checkdir "$DIR_OUT" "/dev/shm"; then
+
+main() {
+    # DEBUG: Print environment variables
+    vbm "echo $(printenv)";
+    # Process arguments
+    processArguments "$@";
+    ## Act upon arguments
+    ### Determine working directory
+    magicInitWorkingDir; # Sets dir_tmp from argTempDirPriority
+    ### Set output encryption and compression option strings
+    #### React to "-r" ("encryption recipients") option
+    magicParseRecipientArgs; # Updates recPubKeysValid, cmd_encrypt[_suffix] from argRecPubKeys
+    #### React to "-c" ("compression") option
+    magicParseCompressionArg; # Updates cmd_compress[_suffix]
+    #### React to "-R" ("recipient directory") option
+    magicParseRecipientDir; # Updates recPubKeysValid
+    #### React to custom buffer and script TTL options ("-b", "-B")
+    magicParseCustomTTL; # Sets custom scriptTTL_TE and/or bufferTTL if specified
+
+    # Check that critical apps and dirs are available, display missing ones.
+    if ! checkapp gpspipe tar && ! checkdir "$dirOut" "dir_tmp"; then
        yell "ERROR:Critical components missing.";
        displayMissing; yell "Exiting."; exit 1; fi
 
        yell "ERROR:Critical components missing.";
        displayMissing; yell "Exiting."; exit 1; fi
 
-    # Set script lifespan
-    setScriptTTL "$SCRIPT_TTL";
+    # Set script lifespan (scriptTTL from scriptTTL_TE)
+    magicSetScriptTTL "$scriptTTL_TE";
+    ## Note: scriptTTL_TE is time element string (ex: "day") while scriptTTL is integer seconds
 
 
-    # File name substring: encoded bufferTTL
-    bufferTTL_STR="$(timeDuration $BUFFER_TTL)";
+    # File name substring (ISO-8601 duration from bufferTTL)
+    bufferTTL_STR="$(timeDuration "$bufferTTL")" && vbm "DEBUG:bufferTTL_STR:$bufferTTL_STR";
 
     # Init temp working dir
 
     # Init temp working dir
-    try mkdir "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP";
+    try mkdir "$dir_tmp" && vbm "DEBUG:Working dir created at dir_tmp:$dir_tmp";
 
     # Initialize 'tar' archive
     ## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
 
     # Initialize 'tar' archive
     ## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
-    PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
-       vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
-    ## Write bkgpslog version to DIR_TMP/VERSION
-    FILEOUT_VERSION="$(dateTimeShort)..VERSION";
-    PATHOUT_VERSION="$DIR_TMP"/"$FILEOUT_VERSION";
-    echo "$(dateTimeShort):$(basename "$0")"" Version:""$SCRIPT_VERSION" >> "$PATHOUT_VERSION" && vbm "DEBUG:VERSION created:$PATHOUT_VERSION";
-    ## Check if PATHOUT_TAR already exists.
-    if [[ -f "$PATHOUT_TAR" ]]; then
-       vbm "STATUS:Output tar already exists:$PATHOUT_TAR";
-       ### Check if preexisting tar is appendable.
-       FILEOUT_APPENDTEST="$(dateTimeShort)..RESUMING_LOGGING_SESSION.txt";
-       PATHOUT_APPENDTEST="$DIR_TMP"/"$FILEOUT_APPENDTEST" && \
-           vbm "DEBUG:Set PATHOUT_APPENDTEST to:$PATHOUT_APPENDTEST";
-       echo "$(dateTimeShort):""$(basename "$0")"" version $SCRIPT_VERSION resuming logging session." >> "$PATHOUT_APPENDTEST" && \
-           vbm "DEBUG:""$PATHOUT_APPENDTEST"" created."
-       if ! tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$FILEOUT_APPENDTEST"; then
-           ### If not appendable, label tar broken, move tar, proceed.
-           mv "$PATHOUT_TAR" "${PATHOUT_TAR%.*}""-broken$(dateTimeShort)".tar && \
-               vbm "DEBUG:tar not writable, moving out of the way $PATHOUT_TAR";
-       fi
-    else
-       vbm "STATUS:Output tar does not already exist. Creating:$PATHOUT_TAR"
-       ### If (no preexisting|appendable) tar found, create empty tar archive at PATHOUT_TAR
-       try tar --create --directory="$DIR_TMP" --file="$PATHOUT_TAR" --files-from=/dev/null && \
-           vbm "DEBUG:Empty tar created at:$PATHOUT_TAR";
-    fi 
-    ## Append VERSION file to PATHOUT_TAR
-    try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$FILEOUT_VERSION" && \
-       vbm "DEBUG:VERSION added to $PATHOUT_TAR";
-    
-    # Record gps data until script lifespan ends
-    declare debugCounter; debugCounter="0"; # set debug counter
+    pathout_tar="$dirOut"/"$(dateShort "$(date --date="$bufferTTL seconds ago" --iso-8601=seconds)")".."$scriptHostname""_location""$cmd_compress_suffix""$cmd_encrypt_suffix".tar && \
+       vbm "STATUS:Set pathout_tar to:$pathout_tar";
+    ## Check that pathout_tar is a tar. Rename old and create empty one otherwise.
+    checkMakeTar "$pathout_tar" && vbm "DEBUG:Confirmed or Created to be a tar:$pathout_tar";
+    ## Append VERSION file to pathout_tar
+    magicWriteVersion;
+
+    # Define GPS conversion commands
+    cmd_conv_nmea="tee /dev/null " && vbm "STATUS:Set cmd_conv_nmea to:$cmd_conv_nmea"; # tee as passthrough
+    cmd_conv_gpx="gpsbabel -i nmea -f - -o gpx -F - " && vbm "STATUS:Set cmd_conv_gpx to:$cmd_conv_gpx"; # convert NMEA to GPX
+    cmd_conv_kml="gpsbabel -i nmea -f - -o kml -F - " && vbm "STATUS:Set cmd_conv_kml to:$cmd_conv_kml"; # convert NMEA to KML
+
+    # MAIN LOOP:Record gps data until script lifespan ends
+    timeBufferFirstNS="$(timeEpochNS)"; bufferRound=0; bufferTTL_AdjFloat="$bufferTTL";
     while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
     while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
-       timeBufferStart="$(dateTimeShort)"; # Note start time
-       # Determine file paths (time is start of buffer period)
-       FILEOUT_BASENAME="$timeBufferStart""--""$bufferTTL_STR""..""$SCRIPT_HOSTNAME""_location" && vbm "STATUS:Set FILEOUT_BASENAME to:$FILEOUT_BASENAME";
-       ## Files saved to DIR_TMP
-       PATHOUT_NMEA="$DIR_TMP"/"$FILEOUT_BASENAME".nmea"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set PATHOUT_NMEA to:$PATHOUT_NMEA";
-       PATHOUT_GPX="$DIR_TMP"/"$FILEOUT_BASENAME".gpx"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set PATHOUT_GPX to:$PATHOUT_GPX";
-       PATHOUT_KML="$DIR_TMP"/"$FILEOUT_BASENAME".kml"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set PATHOUT_KML to:$PATHOUT_KML";
-       ## Files saved to disk (DIR_OUT)
-       ### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
-       PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
-           vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR"
-       # Define GPS conversion commands
-       CMD_CONV_NMEA="tee /dev/null " && vbm "STATUS:Set CMD_CONV_NMEA to:$CMD_CONV_NMEA"; # tee as passthrough
-       CMD_CONV_GPX="gpsbabel -i nmea -f - -o gpx -F - " && vbm "STATUS:Set CMD_CONV_GPX to:$CMD_CONV_GPX"; # convert NMEA to GPX
-       CMD_CONV_KML="gpsbabel -i nmea -f - -o kml -F - " && vbm "STATUS:Set CMD_CONV_KML to:$CMD_CONV_KML"; # convert NMEA to KML
-       # Fill Bash variable buffer
-       bufferBash="$(timeout "$BUFFER_TTL""s" gpspipe -r)" && vbm "STATUS:Successfully filled bufferBash variable with gpspipe data."; # Record gpspipe nmea data to buffer for bufferTTL seconds
-       # Process bufferBash, save secured chunk set to DIR_TMP
-       vbm "STATUS:Beginning to save data to $DIR_TMP";
-       echo "$bufferBash" | $CMD_CONV_NMEA | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_NMEA" & # Create NMEA file (secured if requested)
-       echo "$bufferBash" | $CMD_CONV_GPX  | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_GPX" & # Create GPX file (secured if requested)
-       echo "$bufferBash" | $CMD_CONV_KML  | $CMD_COMPRESS | $CMD_ENCRYPT > "$PATHOUT_KML" & # Create KML file (secured if requested)
-       # Append each secured chunk in memory dir (DIR_TMP) to file on disk (PATHOUT_TAR in DIR_OUT)
-       vbm "STATUS:DIR_TMP     :$DIR_TMP";
-       vbm "STATUS:PATHOUT_TAR :$PATHOUT_TAR";
-       vbm "STATUS:PATHOUT_NMEA:$PATHOUT_NMEA";
-       vbm "STATUS:PATHOUT_NMEA:$PATHOUT_GPX";
-       vbm "STATUS:PATHOUT_NMEA:$PATHOUT_KML";
-       try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_NMEA")" && \
-           vbm "DEBUG:Appended NMEA location data $PATHOUT_NMEA to $PATHOUT_TAR";
-       try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_GPX")" && \
-           vbm "DEBUG:Appended GPX location data $PATHOUT_GPX to $PATHOUT_TAR";
-       try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$(basename "$PATHOUT_KML")" && \
-           vbm "DEBUG:Appended KML location $PATHOUT_KML to $PATHOUT_TAR";
-       # Remove secured chunks from DIR_TMP
-       try rm "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
-       # Reset buffer and filenames
-       unset bufferBash FILEOUT_BASENAME PATHOUT_NMEA PATHOUT_GPX PATHOUT_KML PATHOUT_TAR timeBufferStart;
-       vbm "DEBUG:Completed buffer session $debugCounter ." 1>&2;
-       ((debugCounter++))
-    done
+       if ! [[ -d "$dir_tmp" ]]; then yell "ERROR:dir_tmp existence failure:$dir_tmp"; try mkdir "$dir_tmp" && vbm "DEBUG:Working dir recreated dir_tmp:$dir_tmp"; fi
+       magicParseRecipientDir;
+       magicGatherWriteBuffer &
+       sleep "$bufferTTL_AdjFloat"; # adjusted by magicBufferSleepPID
+       ((bufferRound++));
+       magicBufferSleepPID; # Calculates bufferTTL_AdjFloat from bufferTTL given buffer expected start time vs. actual
+    done    
 
 
-    # Remove DIR_TMP
-    try rm -r "$DIR_TMP";
+    # Cleanup
+    ## Remove dir_tmp
+    try rm -r "$dir_tmp" && vbm "Removed dir_tmp:$dir_tmp";
 
 
-    vbm "STATUS:Main function finished."
+    vbm "STATUS:Main function finished.";
 } # Main function.
 #===END Declare local script functions===
 #==END Define script parameters==
 } # Main function.
 #===END Declare local script functions===
 #==END Define script parameters==
@@ -783,3 +1358,6 @@ main() {
 main "$@" # Run main function.
 exit 0;
 #==END Perform work and exit==
 main "$@" # Run main function.
 exit 0;
 #==END Perform work and exit==
+
+# Author: Steven Baltakatei Sandoval;
+# License: GPLv3+